<script setup lang="ts">
// get route info
// import { ZoomMtg } from '@zoomus/websdk'
import _ from 'lodash'
import { storeToRefs } from 'pinia'
import { useAccountStore } from '~~/store/account'
import { useCallStore } from '~~/store/call'
import { useUIStore } from '~~/store/UI'
import { useZoomClientStore } from '~~/store/zoomClient'

const zoomClient = useZoomClientStore()
const call = useCallStore()
const { currentCall } = storeToRefs(call)
const recordTimeStamp = computed(() => currentCall.value?.call.record)
const isRecord = ref(false)

const toggle = () => {
  call.toggleRecord(!recordTimeStamp.value)
  ZoomMtg.record({
    error: (error: any) => {
      throw error
    },
    record: isRecord.value,
  })
}
const accountStore = useAccountStore()
const { ableToEnd } = storeToRefs(accountStore)

const recordModal = ref(false)
const endMeetting = ref(false)
const TEXT_RECORD = {
  START_RECORD: '録画開始',
  END_RECORD: '録画終了',
}
const MESSAGE_ALERT = {
  START_RECORD: '配信録画は1度のみ可能です。録画を開始しますか？',
  END_RECORD: '配信録画を終了します。よろしいですか？(再録画は行えません)',
  END_MEETING: '配信を終了します。よろしいですか？',
}
// host
const host = ref(false)
useIntervalFn(() => {
  ZoomMtg.getCurrentUser({
    success: (i: any) => host.value = i.result.currentUser.isHost,
  })
}, 1000)

const ui = useUIStore()
const { mTabFull } = storeToRefs(ui)
</script>

<template>
  <TCallPanel>
    <template #default>
      <div h-full w-full flex flex-col>
        <MInfoBar :lt-sm="mTabFull ? '' : 'hidden'" />
        <MTab class="flex-1 w-full">
          <ATabContent title="info" :lt-sm="mTabFull ? '' : 'hidden'">
            <MAttendees />
          </ATabContent>
          <ATabContent title="comment" :lt-sm="mTabFull ? '' : 'hidden'">
            <OChat />
          </ATabContent>
          <ATabContent title="question" :lt-sm="mTabFull ? '' : 'hidden'">
            <OQuestion />
          </ATabContent>
          <ATabContent title="poll" :lt-sm="mTabFull ? '' : 'hidden'">
            <OPoll />
          </ATabContent>
        </MTab>
      </div>
    </template>
    <template #bottom>
      <div class="w-full h-full flex justify-start px-3 items-center bg-neutral-900 gap-2 pr-6">
        <button
          v-if="ableToEnd && host"
          class="min-w-[160px] text-base px-4 py-2 border-white border text-white rounded-md bg-gray-500 hover:bg-gray-400 my-1"
          @click="recordModal = true"
        >
          {{ recordTimeStamp ? TEXT_RECORD.END_RECORD : TEXT_RECORD.START_RECORD }}
        </button>
        <button
          v-if="ableToEnd && host"
          class="min-w-[160px] text-base px-4 py-2 border-white border text-white rounded-md bg-gray-500 hover:bg-gray-400 my-1"
          @click="endMeetting = true"
        >
          配信終了
        </button>
      </div>
    </template>
    <template #left>
      <AMeetingClientPortal />
      <AWarningModel
        v-if="recordModal"
        class="pointer-events-auto"
        :text="recordTimeStamp ? MESSAGE_ALERT.END_RECORD : MESSAGE_ALERT.START_RECORD" @close="recordModal = false" @accept="() => {
          isRecord = !isRecord
          toggle()
          recordModal = false
        }"
      />
      <AWarningModel
        v-if="endMeetting"
        class="pointer-events-auto" :text="MESSAGE_ALERT.END_MEETING" @close="endMeetting = false" @accept="() => {
          zoomClient.endClient()
          endMeetting = false
        }"
      />
    </template>
  </TCallPanel>
</template>

<style lang="scss">
.container {
  height: 100%;
  width: 100%;
  max-width: 100vw;
  max-height: 100vh;
  overflow: hidden;
}

.aspectChart {
  aspect-ratio: 1.1;
}

.participants-section-container__participants-footer-bottom {
  > button{
    display: none;
  }
}
.participants-section-container__participants-footer-bottom:not(button:nth-child(4)){
  >button:nth-child(1){
    display: none;
  }
  >button:nth-child(2){
    display: none !important;
  }
}
.participants-section-container__participants-footer-bottom:not(button:nth-child(3)){
  >button:nth-child(1){
    display: none;
  }
  >button:nth-child(2){
    display: block;
  }
}
.participants-section-container__participants-footer-bottom:has(button:nth-child(4)){
  >button:nth-child(1){
    display: none;
  }
  >button:nth-child(2){
    display: none;
  }
  >button:nth-child(3){
    display: none;
  }
}

button[aria-label="more security options"] {
  display: none !important;
}
ul[aria-labelledby="securityOptionMenu"] {
  display: none !important;
}
.reaction-count {
  display: none;
}

.sharer-controlbar-container__main-content {
  display: none;
}
.common-ui-component__dropdown-divider {
  display: none;
}
li:has(>a[aria-label="全画面表示"]) {
  display: none;
}
div:has(>button[data-a-l="5-2-0"]) {
  display: none;
}
button[data-a-l="5-0-0"] {
  display: none;
}
button[data-a-l="5-0-2"] {
  display: none;
}
button[data-a-l="5-0-3"] {
  display: none;
}
button[data-a-l="5-0-4"] {
  display: none;
}
button[data-a-l="5-0-5"] {
  display: none;
}
button[data-a-l="5-0-6"] {
  display: none;
}
.reaction-simple-picker__row {
  margin-right: 4px;
}
[feature-type="record"] {
  display: none !important;
}
[feature-type="pasue-stop-record"]{
  display: none !important;
}
</style>

<route lang="yaml"></route>
